Index: trunk/zoo-project/HISTORY.txt
===================================================================
--- trunk/zoo-project/HISTORY.txt	(revision 721)
+++ trunk/zoo-project/HISTORY.txt	(revision 725)
@@ -1,3 +1,4 @@
 Version 1.5.0-dev
+  * Completely rewrite of the documentation to use moderne style
   * Fix asynchronous POST request on WIN32 platforms
   * Add utils/registry service
Index: trunk/zoo-project/zoo-kernel/caching.c
===================================================================
--- trunk/zoo-project/zoo-kernel/caching.c	(revision 721)
+++ trunk/zoo-project/zoo-kernel/caching.c	(revision 725)
@@ -215,5 +215,5 @@
 	    fcontent=(char*)malloc((hInternet->ihandle[index].nDataLen+1)*sizeof(char));
 	    if(fcontent == NULL){
-	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+	      return errorException(*m, _("Unable to allocate memory"), "InternalError",NULL);
 	    }
 	    size_t dwRead;
@@ -233,5 +233,5 @@
 	    tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
 	    if(tmpMap->value==NULL){
-	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+	      return errorException(*m, _("Unable to allocate memory"), "InternalError",NULL);
 	    }
 	    memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
@@ -354,5 +354,5 @@
   tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
   if(tmpMap->value==NULL)
-    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+    return errorException(*m, _("Unable to allocate memory"), "InternalError",NULL);
   memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
 
Index: trunk/zoo-project/zoo-kernel/locale/po/messages.po
===================================================================
--- trunk/zoo-project/zoo-kernel/locale/po/messages.po	(revision 721)
+++ trunk/zoo-project/zoo-kernel/locale/po/messages.po	(revision 725)
@@ -4,10 +4,9 @@
 # Gerald Fenoy <gerald.fenoy@geolabs.fr>, 2015.
 #
-#, fuzzy
-msgid ""
-msgstr ""
-"Project-Id-Version: ZOO-Kernel Internationalization\n"
+msgid ""
+msgstr ""
+"Project-Id-Version: ZOO-Kernel 1.5.0\n"
 "Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
-"POT-Creation-Date: 2015-07-01 22:23+0200\n"
+"POT-Creation-Date: 2015-07-02 18:06+0200\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
@@ -19,12 +18,12 @@
 
 #: caching.c:217 caching.c:235 caching.c:356 request_parser.c:214
-#: request_parser.c:225 request_parser.c:262 request_parser.c:441
-#: request_parser.c:537 request_parser.c:562 request_parser.c:665
-#: request_parser.c:782 request_parser.c:1112 request_parser.c:1204
-#: server_internal.c:1077 zcfg2yaml.c:38 zoo_service_loader.c:259
-#: zoo_service_loader.c:880 zoo_service_loader.c:1363
-#: zoo_service_loader.c:1559 server_internal.c:1082
-msgid "Unable to allocate memory."
-msgstr "Unable to allocate memory."
+#: request_parser.c:225 request_parser.c:262 request_parser.c:403
+#: request_parser.c:414 request_parser.c:441 request_parser.c:537
+#: request_parser.c:562 request_parser.c:665 request_parser.c:782
+#: request_parser.c:1112 request_parser.c:1204 zcfg2yaml.c:38
+#: zoo_service_loader.c:259 zoo_service_loader.c:880 zoo_service_loader.c:1363
+#: zoo_service_loader.c:1559
+msgid "Unable to allocate memory"
+msgstr "Unable to allocate memory"
 
 #: caching.c:344
@@ -52,8 +51,4 @@
 msgstr "Unable to find a valid protocol to download the remote file %s"
 
-#: request_parser.c:403 request_parser.c:414
-msgid "Unable to allocate memory"
-msgstr "Unable to allocate memory"
-
 #: request_parser.c:613
 msgid "Unable to add a request in the queue."
@@ -115,10 +110,10 @@
 msgstr "are"
 
-#: response_print.c:1628
+#: response_print.c:1630
 #, c-format
 msgid "The service \"%s\" ran successfully."
 msgstr "The service \"%s\" ran successfully."
 
-#: response_print.c:1636
+#: response_print.c:1638
 #, c-format
 msgid ""
@@ -129,43 +124,43 @@
 "get the up-to-date status of the service."
 
-#: response_print.c:1642
-#, c-format
-msgid ""
+#: response_print.c:1644
+#, fuzzy, c-format
+msgid ""
+"The service \"%s\" was accepted by the ZOO-Kernel and is running as a "
+"background task. Please access the URL in the statusLocation attribute "
+"provided in this document to get the up-to-date status and results."
+msgstr ""
 "The service \"%s\" was accepted by the ZOO kernel and is running as a "
 "background task. Please access the URL in the statusLocation attribute "
 "provided in this document to get the up-to-date status and results."
-msgstr ""
-"The service \"%s\" was accepted by the ZOO kernel and is running as a "
-"background task. Please access the URL in the statusLocation attribute "
-"provided in this document to get the up-to-date status and results."
-
-#: response_print.c:1659
+
+#: response_print.c:1661
 msgid "No more information available"
 msgstr "No more information available"
 
-#: response_print.c:1666
+#: response_print.c:1668
 #, c-format
 msgid "error code not know : %i\n"
 msgstr "error code not know : %i\n"
 
-#: response_print.c:1758
+#: response_print.c:1760
 msgid "Lock failed."
 msgstr "Lock failed."
 
-#: response_print.c:1771
+#: response_print.c:1773
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the ExecuteResponse."
 msgstr "Unable to create the file \"%s\" for storing the ExecuteResponse."
 
-#: response_print.c:2288
+#: response_print.c:2290
 msgid "No debug message available"
 msgstr "No debug message available"
 
-#: response_print.c:2376
+#: response_print.c:2378
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the session maps."
 msgstr "Unable to create the file \"%s\" for storing the session maps."
 
-#: response_print.c:2392
+#: response_print.c:2394
 msgid ""
 "Unable to run the Service. The message returned back by the Service was the "
@@ -175,5 +170,5 @@
 "following: "
 
-#: response_print.c:2393
+#: response_print.c:2395
 #, c-format
 msgid ""
@@ -184,5 +179,5 @@
 "following: %s"
 
-#: response_print.c:2396 response_print.c:2397
+#: response_print.c:2398 response_print.c:2399
 msgid ""
 "Unable to run the Service. No more information was returned back by the "
@@ -192,10 +187,10 @@
 "Service."
 
-#: response_print.c:2484
+#: response_print.c:2486
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the %s final result."
 msgstr "Unable to create the file \"%s\" for storing the %s final result."
 
-#: response_print.c:2570
+#: response_print.c:2572
 #, c-format
 msgid ""
@@ -222,12 +217,20 @@
 msgstr "The job cannot be removed, a file cannot be removed"
 
-#: server_internal.c:1088 zoo_service_loader.c:276 zoo_service_loader.c:1384
-#: zoo_service_loader.c:1427 server_internal.c:1093
+#: server_internal.c:1063
+msgid "Unable to open the registry directory."
+msgstr ""
+
+#: server_internal.c:1082
+msgid "Unable to allocate memory."
+msgstr "Unable to allocate memory."
+
+#: server_internal.c:1093 zoo_service_loader.c:276 zoo_service_loader.c:1384
+#: zoo_service_loader.c:1427
 #, c-format
 msgid "Unable to parse the ZCFG file: %s (%s)"
 msgstr "Unable to parse the ZCFG file: %s (%s)"
 
-#: server_internal.c:1091 zoo_service_loader.c:279 zoo_service_loader.c:1389
-#: zoo_service_loader.c:1431 server_internal.c:1096
+#: server_internal.c:1096 zoo_service_loader.c:279 zoo_service_loader.c:1389
+#: zoo_service_loader.c:1431
 #, c-format
 msgid "Unable to parse the ZCFG file: %s."
@@ -308,5 +311,6 @@
 
 #: zoo_service_loader.c:1238
-msgid "The specified path path does not exist."
+#, fuzzy
+msgid "The specified path does not exist."
 msgstr "The specified path path does not exist."
 
@@ -359,6 +363,2 @@
 msgid "Unable to run the child process properly"
 msgstr "Unable to run the child process properly"
-
-#: server_internal.c:1063
-msgid "Unable to open the registry directory."
-msgstr ""
Index: trunk/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- trunk/zoo-project/zoo-kernel/request_parser.c	(revision 721)
+++ trunk/zoo-project/zoo-kernel/request_parser.c	(revision 725)
@@ -212,5 +212,5 @@
       {
 	free(cursor_input);
-	return errorException (*main_conf, _("Unable to allocate memory."),
+	return errorException (*main_conf, _("Unable to allocate memory"),
 			       "InternalError", NULL);
       }
@@ -223,5 +223,5 @@
 	  {
 	    free(cursor_input);
-	    return errorException (*main_conf, _("Unable to allocate memory."),
+	    return errorException (*main_conf, _("Unable to allocate memory"),
 				   "InternalError", NULL);
 	  }
@@ -260,5 +260,5 @@
 		    free(cursor_input);
 		    return errorException (*main_conf,
-					   _("Unable to allocate memory."),
+					   _("Unable to allocate memory"),
 					   "InternalError", NULL);
 		  }
@@ -439,5 +439,5 @@
 			  return errorException (*main_conf,
 						 _
-						 ("Unable to allocate memory."),
+						 ("Unable to allocate memory"),
 						 "InternalError", NULL);
 			}
@@ -535,5 +535,5 @@
 			  return errorException (*main_conf,
 						 _
-						 ("Unable to allocate memory."),
+						 ("Unable to allocate memory"),
 						 "InternalError", NULL);
 			}
@@ -560,5 +560,5 @@
 			  return errorException (*main_conf,
 						 _
-						 ("Unable to allocate memory."),
+						 ("Unable to allocate memory"),
 						 "InternalError", NULL);
 			}
@@ -663,5 +663,5 @@
 				      return errorException (*main_conf,
 							     _
-							     ("Unable to allocate memory."),
+							     ("Unable to allocate memory"),
 							     "InternalError",
 							     NULL);
@@ -780,5 +780,5 @@
 				    return errorException (*main_conf,
 							   _
-							   ("Unable to allocate memory."),
+							   ("Unable to allocate memory"),
 							   "InternalError",
 							   NULL);
@@ -1110,5 +1110,5 @@
 	  if (tmpmaps == NULL)
 	    {
-	      return errorException (*main_conf, _("Unable to allocate memory."),
+	      return errorException (*main_conf, _("Unable to allocate memory"),
 				     "InternalError", NULL);
 	    }
@@ -1202,5 +1202,5 @@
 	      return errorException (*main_conf,
 				     _
-				     ("Unable to allocate memory."),
+				     ("Unable to allocate memory"),
 				     "InternalError", NULL);
 	    }
Index: trunk/zoo-project/zoo-kernel/response_print.c
===================================================================
--- trunk/zoo-project/zoo-kernel/response_print.c	(revision 721)
+++ trunk/zoo-project/zoo-kernel/response_print.c	(revision 725)
@@ -1642,5 +1642,5 @@
     case SERVICE_ACCEPTED:
       nc1 = xmlNewNode(ns, BAD_CAST "ProcessAccepted");
-      sprintf(sMsg,_("The service \"%s\" was accepted by the ZOO kernel and is running as a background task. Please access the URL in the statusLocation attribute provided in this document to get the up-to-date status and results."),serv->name);
+      sprintf(sMsg,_("The service \"%s\" was accepted by the ZOO-Kernel and is running as a background task. Please access the URL in the statusLocation attribute provided in this document to get the up-to-date status and results."),serv->name);
       nc3=xmlNewText(BAD_CAST sMsg);
       xmlAddChild(nc1,nc3);
Index: trunk/zoo-project/zoo-kernel/zcfg2yaml.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zcfg2yaml.c	(revision 721)
+++ trunk/zoo-project/zoo-kernel/zcfg2yaml.c	(revision 725)
@@ -36,5 +36,5 @@
   s1=(service*)malloc(SERVICE_SIZE);
   if(s1 == NULL){ 
-    return errorException(m, _("Unable to allocate memory."),"InternalError",NULL);
+    return errorException(m, _("Unable to allocate memory"),"InternalError",NULL);
   }
   int t=getServiceFromFile(m,conf_file,&s1);
Index: trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 721)
+++ trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 725)
@@ -257,5 +257,5 @@
               {
                 dup2 (saved_stdout, fileno (stdout));
-                errorException (m, _("Unable to allocate memory."),
+                errorException (m, _("Unable to allocate memory"),
                                 "InternalError", NULL);
                 return -1;
@@ -878,5 +878,5 @@
   if (m == NULL)
     {
-      return errorException (m, _("Unable to allocate memory."),
+      return errorException (m, _("Unable to allocate memory"),
                              "InternalError", NULL);
     }
@@ -1236,5 +1236,5 @@
 	if (dirp == NULL)
 	  {
-	    errorException (m, _("The specified path path does not exist."),
+	    errorException (m, _("The specified path does not exist."),
 			    "InvalidParameterValue", conf_dir);
 	    freeMaps (&m);
@@ -1361,5 +1361,5 @@
 				    return errorException (m,
 							   _
-							   ("Unable to allocate memory."),
+							   ("Unable to allocate memory"),
 							   "InternalError",
 							   NULL);
@@ -1557,5 +1557,5 @@
       free (REQUEST);
       free (SERVICE_URL);
-      return errorException (m, _("Unable to allocate memory."),
+      return errorException (m, _("Unable to allocate memory"),
                              "InternalError", NULL);
     }