Index: trunk/docs/client/howto.rst
===================================================================
--- trunk/docs/client/howto.rst	(revision 725)
+++ trunk/docs/client/howto.rst	(revision 754)
@@ -64,8 +64,10 @@
 .. warning:: Using different versions of Hogan to compile and to use in a web application may lead to compatibility issue.
 
-Everything is now ready to work with :ref:`ZOO-Client <client-what>`. Read the :ref:`next section <client-example>` for an example JavaScript application.
+Everything is now ready to work with :ref:`ZOO-Client
+<client-what>`. Read the :ref:`next section <client-example>` for an
+example JavaScript application. 
 
-Building ZOO-Client documentation
----------------------------------
+Building ZOO-Client API documentation
+-------------------------------------
 
 You may also build the ZOO-Client API documentation using `jsDoc
@@ -78,4 +80,10 @@
 
 This will build HTML documentation in a new directory named ``/out`` in
-your working directory.
+your working directory. 
 
+.. note:: 
+    Building the ZOO-Client API documentation is optional, please
+    refer to `the up-to-date ZOO-Client API Documentation
+    <http://www.zoo-project.org/jsDoc/index.html>`__ for the current
+    API version. 
+
Index: trunk/docs/client/what.rst
===================================================================
--- trunk/docs/client/what.rst	(revision 725)
+++ trunk/docs/client/what.rst	(revision 754)
@@ -5,5 +5,6 @@
 
 ZOO-Client is a client-side JavaScript API which provides simple methods
-for interacting with `WPS <http://www.opengeospatial.org/standards/wps/>`__ server from web
+for interacting with `WPS
+<http://www.opengeospatial.org/standards/wps/>`__ server from web
 applications. It is helpful for sending requests to any WPS compliant
 server (such as :ref:`kernel_index`) and to parse the output responses
@@ -15,9 +16,15 @@
 
 ZOO-Client relies on modern JavaScript libraries and can be seamlessly
-integrated in new or existing web platforms or applications. ZOO-Client works by expanding the tags available in WPS specific
-templates using values provided by a JavaScript hash or object. It
-allows to build valid WPS requests and to send them to a WPS server. It
-also provides functions to easily parse and reuse the output XML
-responses. Read the :ref:`next section <client-howto>` to get started.
+integrated in new or existing web platforms or
+applications. ZOO-Client works by expanding the tags available in WPS
+specific templates using values provided by a JavaScript hash or
+object. It allows to build valid WPS requests and to send them to a
+WPS server. It also provides functions to easily parse and reuse the
+output XML responses. Read the :ref:`next section <client-howto>` to
+get started.
+
+Please, refer to the `ZOO-Client API documentation
+<http://www.zoo-project.org/jsDoc/index.html>`__ for accessing the
+up-to-date documentation.
 
 
@@ -26,8 +33,8 @@
 
 ZOO-Client uses logic-less `Mustache <http://mustache.github.io/>`__
-templates for creating well-formed WPS requests. Templates are called
-*logic-less* because they do not contain any *if* statements, *else*
-clauses, or *for* loops, but only **tags**. Some tags are dynamically replaced by a
-value or a series of values.
+templates for creating well-formed WPS requests. Please, refer to the
+`ZOO-Client API documentation
+<http://www.zoo-project.org/jsDoc//module-wpsPayload.html>`__ for more
+details about the functions using the templates. 
 
 
@@ -37,11 +44,7 @@
 *GetCapabilities* requests are created using the following template:
 
-::
-   
-   <wps:GetCapabilities xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:wps="http://www.opengis.net/wps/1.0.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsGetCapabilities_request.xsd" language="{{language}}" service="WPS">
-    <wps:AcceptVersions>
-        <ows:Version>1.0.0</ows:Version>
-    </wps:AcceptVersions>
-   </wps:GetCapabilities>
+.. include:: ../../zoo-project/zoo-client/lib/tpl/payload_GetCapabilities.mustache
+    :code: xml
+
 
 
@@ -51,11 +54,6 @@
 *DescribeProcess* requests are created using the following template:
 
-::
-
-   <DescribeProcess xmlns="http://www.opengis.net/wps/1.0.0" xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsDescribeProcess_request.xsd" service="WPS" version="1.0.0" language="{{language}}">
-   {{#identifiers}}
-   <ows:Identifier>{{.}}</ows:Identifier>
-   {{/identifiers}}
-   </DescribeProcess>
+.. include:: ../../zoo-project/zoo-client/lib/tpl/payload_DescribeProcess.mustache
+    :code: xml
 
 
@@ -65,87 +63,5 @@
 *Execute* requests are created using a more complex template, as shown bellow:
 
-::
+.. include:: ../../zoo-project/zoo-client/lib/tpl/payload_Execute.mustache
+    :code: xml
 
-   <wps:Execute service="WPS" version="1.0.0" xmlns:wps="http://www.opengis.net/wps/1.0.0" xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0../wpsExecute_request.xsd" language="{{language}}">
-   <!-- template-version: 0.21 -->
-	<ows:Identifier>{{Identifier}}</ows:Identifier>
-	<wps:DataInputs>
-	{{#DataInputs}}
-	{{#is_literal}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Data>
-				<wps:LiteralData{{#dataType}} dataType="{{dataType}}"{{/dataType}}>{{value}}</wps:LiteralData>
-			</wps:Data>
-		</wps:Input>
-		{{/is_literal}}
-		{{#is_bbox}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Data>
-				<wps:BoundingBoxData ows:crs="{{crs}}" ows:dimensions="{{dimension}}">
-            <ows:LowerCorner>{{lowerCorner}}</ows:LowerCorner>
-            <ows:UpperCorner>{{upperCorner}}</ows:UpperCorner>
-         </wps:BoundingBoxData>
-			</wps:Data>
-		</wps:Input>
-		{{/is_bbox}}
-		{{#is_complex}}
-		{{#is_reference}}
-		{{#is_get}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Reference xlink:href="{{href}}"{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}/>
-		</wps:Input>
-		{{/is_get}}
-		{{#is_post}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Reference xlink:href="{{href}}" method="{{method}}">
-			{{#headers}}
-			  <wps:Header key="{{key}}" value="{{value}}" />
-			  {{/headers}}
-			  <wps:Body>{{{value}}}</wps:Body>
-			</wps:Reference>
-		</wps:Input>
-		{{/is_post}}
-		{{/is_reference}}
-		{{^is_reference}}
-		<wps:Input>
-      <ows:Identifier>{{identifier}}</ows:Identifier>
-      <wps:Data>
-        <wps:ComplexData{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>{{#is_XML}}
-	 {{{value}}}{{/is_XML}}{{^is_XML}}<![CDATA[{{{value}}}]]>{{/is_XML}}
-        </wps:ComplexData>
-      </wps:Data>
-    </wps:Input>
-    {{/is_reference}}
-    {{/is_complex}}
-    {{/DataInputs}}
-	</wps:DataInputs>	
-	<wps:ResponseForm>
-	{{#RawDataOutput}}
-	{{#DataOutputs}}
-    <wps:RawDataOutput mimeType="{{mimeType}}">
-      <ows:Identifier>{{identifier}}</ows:Identifier>
-    </wps:RawDataOutput>
-    {{/DataOutputs}}
-    {{/RawDataOutput}}
-    {{^RawDataOutput}}
-    <wps:ResponseDocument{{#storeExecuteResponse}} storeExecuteResponse="{{storeExecuteResponse}}"{{/storeExecuteResponse}}{{#lineage}} lineage="{{lineage}}"{{/lineage}}{{#status}} status="{{status}}"{{/status}}>
-    {{#DataOutputs}}
-    {{#is_literal}}
-      <wps:Output{{#dataType}} dataType="{{dataType}}"{{/dataType}}{{#uom}} uom="{{uom}}"{{/uom}}>
-        <ows:Identifier>{{identifier}}</ows:Identifier>
-      </wps:Output>
-      {{/is_literal}}
-      {{^is_literal}}
-      <wps:Output{{#asReference}} asReference="{{asReference}}"{{/asReference}}{{#schema}} schema="{{schema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>
-        <ows:Identifier>{{identifier}}</ows:Identifier>
-      </wps:Output>
-      {{/is_literal}}
-      {{/DataOutputs}}
-    </wps:ResponseDocument>
-    {{/RawDataOutput}}
-    </wps:ResponseForm>	
-    </wps:Execute>